(function() {
  var Room, currentRoom, fs, parseGame, parseRoom, replaceQuotes, src;

  fs = require('fs');

  if (process.argv[2]) {
    src = __dirname.substring(0, __dirname.lastIndexOf("/")) + '/' + process.argv[2];
  } else {
    src = __dirname.substring(0, __dirname.lastIndexOf("/")) + '/' + 'game';
  }

  Room = (function() {

    function Room(name) {
      this.title(name);
    }

    Room.prototype.title = function(name) {
      return this.name = name;
    };

    return Room;

  })();

  currentRoom = new Room("Nowhere");

  replaceQuotes = function(data) {
    data = data.replace(/<</g, "«");
    data = data.replace(/>>/g, "»");
    data = data.replace(/"(\w)/g, function($0, $1) {
      return '«' + $1;
    });
    data = data.replace(/(\w)"/g, function($0, $1) {
      return '»' + $1;
    });
    data = data.replace(/,,/g, "„");
    data = data.replace(/''/g, "”");
    return data;
  };

  parseRoom = function(data) {
    var html_blocks, matches, titles, urls;
    urls = Array();
    titles = Array();
    html_blocks = Array();
    data = data.replace(/\r(\n)?/g, "\n");
    data = data.replace(/\t/g, " ");
    data = data.replace(/^[ \t]+$/g, "");
    data = data.replace(/(\S)\s+$/, function($0, $1) {
      return $1;
    });
    matches = data.match(/^(.+)\n[=-]+\n+/gm);
    if (matches.length > 1) {
      console.error("Error: there is more than one room title.\nThe matching titles are:");
      console.error(matches);
      process.exit(1);
    }
    matches = data.match(/^(.+)\n[=-]+\n+/m);
    return currentRoom.title(matches[1]);
  };

  parseGame = function(err, data) {
    if (err) {
      throw err;
      return data;
    }
    return parseRoom(data.toString());
  };

  fs.readFile(src + '/main', parseGame);

}).call(this);
